var SFormsLoader = function(options){
    var _objMng = function(options){
        this.options = options;
        this.params = {};
    }

    _objMng.prototype = {
        frame_id: '',
        init : function(){
            this.drawIframe();
            this.correctTimers();
        },
        registerFrame: function(frame){
            var _this = this;
            _this.frame_id = frame.id;
            pm({
                target: window.frames[frame.id],
                type:   "register",
                data:   {id:frame.id},
                url: frame.contentWindow.location
            });

            pm.bind('correct_data', function(data) {
                var iframe = document.getElementById(data.id);
                if (iframe == null) return;
                if (data.height){
                    iframe.style.height=data.height+'px';
                }
            });

            pm.bind('exec_metrika_goals', function(data) {
                var iframe = document.getElementById(data.id);
                if (iframe == null) return;
                for (var i in data.goals){
                    var goal = data.goals[i];
                    if (goal['type']=='ym' && typeof ym !== 'undefined') {
                        ym(goal['counter_id'],'reachGoal',goal['goal_name']);
                    }
                }
            });

            pm.bind('fill_form_data_request', function(data) {
                var iframe = document.getElementById(data.id);
                if (iframe == null) return;
                _this.fillBizonUserData();
                _this.bindBizonPageActions();
            });

            window.setTimeout(function(){
                var counter_start_time = _this._getCookie('start_time');
                var counter_end_time = _this._getCookie('end_time');
                if (counter_start_time!=""){
                    pm({
                        target: window.frames[frame.id],
                        type:   "set_extra_data",
                        data:   {id:frame.id, items: {
                            counter_start_time:counter_start_time,
                            counter_end_time:counter_end_time
                        }},
                        url: frame.contentWindow.location
                    });
                }
            }, 100);

            pm.bind('redirect', function(data) {
                location.href = data.url;
            });
        },
        drawIframe: function(){
            var unique_id = this.options['unique_id'];

            if (window==window.top){
                
                this.params.location = document.location.href;
                this.params.referer = document.referrer;
                this.params.client_height = (!window.opera?document.documentElement.clientHeight:window.innerHeight);
                this.params.client_width = (!window.opera?document.documentElement.clientWidth:window.innerWidth);

                this.options['item_url'] = this._addUrlParams(this.options['item_url'], {loc: encodeURIComponent(this.params.location), ref: encodeURIComponent(this.params.referer)});
                if (location.protocol=='file:'){
                    this.options['item_url'] = 'http:'+this.options['item_url'];
                }
                
                var iframeHtml = '<iframe ' +
                    'src="' + this.options['item_url'] + '" ' +
                    'name="' + unique_id + '_iframe' + '" ' +
                    'id="' + unique_id + '_iframe' + '" ' +
                    'scrolling="no" ' +
                    'frameborder="0" ' +
                    'allowTransparency="true" ' +
                    'marginwidth="0" ' +
                    'marginheight="0" ' +
                    'vspace="0" ' +
                    'hspace="0" ' +
                    'height="'+this.options['height']+'" ' +
                    'width="100%" ' +
                    'onload="window[\'SForm_' + this.options.id + '\'].registerFrame(this)" ' +
                    'style="max-width:600px;height:0;"'+
                    '</iframe>';

                if (this.isBizonPage()){
                    const banner_infodvd = document.querySelector('.banner');
                    banner_infodvd.before(document.getElementById(unique_id));

                    iframeHtml = '' +
                        '<style>' +
                            '.section1 {padding-top: 20px; text-align: center;}.button-section {display: flex;justify-content: center;flex-wrap: wrap;}.prop-section {display: none;}#block-standart {display: inline;}.div-prop {display: none;}' +
                        '</style>' +
                        '<section class="section1" id="section1">' +
                            '<div id="div-prop">' +
                                '<div class="prop-section" id="block-standart" align="center">' +
                                    iframeHtml +
                                '</div>' +
                            '</div>' +
                        '</section>';
                }

                document.getElementById(unique_id).outerHTML  = iframeHtml;

            }
        },

        correctTimers: function(){
            if (this.options.timer_target_date){
                var _this = this;
                if (typeof jQuery != "undefined"){
                    jQuery('.idvd_timer').each(function(){
                        var $source_timer = jQuery(this);
                        var $new_timer = $source_timer.clone();
                        $new_timer.removeClass('autostart');
                        $source_timer.after($new_timer);
                        $source_timer.remove();
                        $new_timer.data('target_date', _this.options.timer_target_date);
                        $new_timer.trigger('timer_run');
                    });
                }
            }
        },

        isBizonPage: function(){
            if (typeof formCmdUrl === "undefined"){
                return false;
            }

            return true;
        },

        bizonUserData: {},
        fillBizonUserData: function(){
            var _this = this;
            var user_data = [];
            if (!this.isBizonPage()){
                return;
            }

            const banner_infodvd = document.querySelector('.banner');
            const section_infodvd = document.querySelector('.section1');

            //  Выбор целевого элемента
            let target = document.getElementById('banner0');
            let source = document.getElementById('div-prop');
            source.style.display = 'none';

            // Конфигурация observer (за какими изменениями наблюдать)
            const config = {
                attributes: true,
                childList: true,
                subtree: true
            };

            let observer = new MutationObserver(function (mutations) {
                let childFirst_a = target.querySelector("a");
                let childFirst_href = childFirst_a.getAttribute('href');
                for (let mutation of mutations) {
                    if (mutation.type === 'attributes') {
                        if (target.getAttribute("style").match(/display\s*\:\s*none/)){
                            childFirst_a.style.display = 'block';
                            source.style.display = 'none';
                        } else {
                            childFirst_a.style.display = 'none';
                            source.style.display = 'block';
                        }
                    }
                }
            });

            observer.observe(target, config);

            if (banner_infodvd.style.display == 'block' || banner_infodvd.style.display==''){
                banner_infodvd.querySelector("a").style.display = 'none';
            }

            if (localStorage && localStorage.lastUserEmail){
                user_data['email'] = localStorage.lastUserEmail;
            }

            if (localStorage && localStorage.lastUserName){
                user_data['uname'] = localStorage.lastUserName;
            }

            if (localStorage && localStorage.lastUserPhone){
                user_data['phone'] = localStorage.lastUserPhone;
            }

            var ssid = '';
            jQuery('script').each(function(){
                var text = jQuery(this).text();
                if (text.indexOf('ssid: \'')!=-1){
                    var matches = text.match(/ssid:\s\'(.+?)\'/);
                    ssid = matches[1];
                }
            });

            jQuery.ajax({
                url: formCmdUrl('loadInitData'),
                method: "POST",
                data: {
                    _csrf: _csrf||'',
                    ssid: ssid,
                    lang: 1,
                },
                dataType: 'json',
                contentType: "application/x-www-form-urlencoded",
                error: function() {
                    fillUserData();
                },
                success: function(json) {
                    if (json['email']){
                        user_data['email'] = json['email'];
                    }
                    if (json['username']){
                        user_data['uname'] = json['username'];
                    }
                    if (json['phone']){
                        user_data['phone'] = json['phone'];
                    }

                    user_data['room_id'] = json['roomid'];
                    _this.bizonUserData = user_data;
                    fillUserData();
                }
            });

            var fillUserData = function(){
                var data = {id:_this.frame_id};
                for (var param_name in user_data){
                    data[param_name] = user_data[param_name];
                }
                pm({
                    target: window.frames[_this.frame_id],
                    type: 'fill_user_data',
                    data: data
                });

                var sendOnlineData = function(){
                    var ic_counter = new Image();
                    var params = new Array();
                    for (var i in user_data){
                        params.push(encodeURIComponent(i)+'='+encodeURIComponent(user_data[i]));
                    }
                    params.push("r="+Math.random());
                    ic_counter.src = "https://www.infoclub.info/bizon.gif?"+params.join('&');
                };
                window.setInterval(function(){
                    sendOnlineData();
                }, 30000);

                sendOnlineData();
            }
        },

        bindBizonPageActions: function(){
            var _this = this;

            $('body').on('click', '#chatframe a, .files a', function(){
                var url = $(this).attr('href');

                if (!url || url.length < 5){
                    return true;
                }

                var click_params = {
                    event: 'link_click',
                    url: url
                };

                var ic_counter = new Image();
                var params = new Array();
                for (var i in click_params){
                    params.push(encodeURIComponent(i)+'='+encodeURIComponent(click_params[i]));
                }

                for (var i in _this.bizonUserData){
                    if (i=='email' || i=='room_id'){
                        params.push(encodeURIComponent(i)+'='+encodeURIComponent(_this.bizonUserData[i]));
                    }
                }
                params.push("r="+Math.random());
                ic_counter.src = "https://www.infoclub.info/bizon.gif?"+params.join('&');

                return true;
            });
        },

        _addUrlParams : function(url, params){
            for (var param_name in params){
                var param_value = params[param_name];
                if (param_value==undefined){
                    continue;
                }
                if (url.indexOf(param_name+'=')>0){
                    var reg = new RegExp(param_name+'=([\\w_\-]+)')
                    url = url.replace(reg, param_name+'='+param_value);
                }else{
                    if (url.indexOf('?')>0){
                        url += '&'+param_name+'='+param_value;
                    }else{
                        url += '?'+param_name+'='+param_value;
                    }
                }
            }

            return url;
        },

        _removeUrlParams: function(url, prefix){
            var urlparts=url.split('?');
            if (urlparts.length>=2) {
                var pars=urlparts[1].split(/[&;]/g);
                for (var i= pars.length; i-->0;){
                    if (pars[i].lastIndexOf(prefix, 0)!==-1) pars.splice(i, 1);
                }
                url= urlparts[0]+(pars.length>0?('?'+pars.join('&')):'');
            }

            return url;
        },

        _getCookie: function(c_name){
            if (document.cookie.length>0)	{
                c_start=document.cookie.indexOf(c_name + "=")
                if (c_start!=-1){
                    c_start=c_start + c_name.length+1
                    c_end=document.cookie.indexOf(";",c_start)
                    if (c_end==-1) c_end=document.cookie.length
                    return unescape(document.cookie.substring(c_start,c_end))
                }
            }
            return ""
        }
    }

    var objMng = new _objMng(options);
    objMng.init();
    return  objMng;
}

window['SFormsLoaderTmpFnc'] = window['sforms_loaders_callbacks'].pop();
if (typeof(window['SFormsLoaderTmpFnc'])=="function"){
    window['SFormsLoaderTmpFnc']();
}

delete window['SFormsLoaderTmpFnc'];


